; III užduotis
; Darbas su failais
; Bendri reikalavimai programoms:
; - parametrai programai perduodami ne prašant juos įvesti, bet komandine eilute 
;	(pvz. dir c:\temp, tasm a.asm)
; - programa turi suprasti pagalbos parametrą, t.y. paleista su parametru /? ji 
;	turi atspausdinti trumpą aprašymą, ką ji daro ir kaip ja naudotis, panašiai 
;	kaip tasm /?, tlink /?
; - turi būti galimybė nurodyti kiek baitų nuskaitinėti iš failo vienu metu 
;	(galima nurodyti programos viduje arba perduoti per parametrą, kaip prog 2 
;	src.txt dest.txt)
; - programa turi mokėti apdoroti įvedimo / išvedimo klaidas. Nustačiusi, kad, 
;	pvz., nurodytas failas neegzistuoja, ji turi apie tai pranešti ir 
;	korektiškai baigti darbą.
; 
; Prielaidos:
; - Įvedimo failuose bus tik ASCII simboliai.
; - Eilutės faile ne ilgesnės nei 1024 simboliai (tose užduotyse, kur reikės 
;	apdoroti eilutes). 
; - Žodžio skirtukas – tarpo (20h) arba tabuliacijos (09h) simbolis.
; 
; Programa, paskaičiuojanti kiek kokių simbolių yra faile (fcount). Į failą 
;	išvedamas simbolis, jo kodas ir kiek kartų jis rastas (simboliams, kurių 
;	ascii kodai iki 20h – vietoje simbolio išvedamas tarpas). Sakykime, 
;	kiekvienas simbolis pasikartos nedaugiau nei 64K kartų.
; Pvz.: fcount srcfile.txt destfile.txt

.MODEL SMALL

; DOS funkcijų numeriai:
GETPSP equ 62h
PRINT equ 09h
OPEN equ 3dh
CREATE equ 3ch
READ equ 3fh
WRITE equ 40h
CLOSE equ 3eh

;******************************************************************************
.STACK

;******************************************************************************
.DATA
	argn dw ?				; parametrų skaičius
	args dw 255 dup (?)		; parametrų nuorodos
	cline db 255 dup (?)	; parametrų eilutės (null-terminated)
	rez dw 0				; rezultatų bylos vardo nuoroda
	rezh dw 0				; rezultatų bylos handle
	duom dw 0				; duomenų bylos vardo nuoroda
	duomh dw 0				; duomenų bylos handle
	readc db 255			; po kiek baitų vienu metu nauskaityti?
	buf db 255 dup (0)
	rez_buf db 15 dup (?)
	
	rez_lent dw 256 dup (0)		; simbolių pasikartojimų lentelė
	
	desimt dw 10
	
	;**************************************************************************
	; eilutės
	;**************************************************************************
	usage_eil db 0ah, 'Asm3 naudojimas: asm3 [parametrai] duom_byla rez_byla', 0dh, 0ah
		db 09h, 'parametrai:', 0dh, 0ah
		db 09h, '/? - isveda naudojimo lentele', 0dh, 0ah
		db 09h, '/c <skaicius> - nurodo po kiek baitu nuskaitineti is bylos'
		db 0dh, 0ah, '$'
	skait_klaida_eil db 'Bylos skaitymo klaida!', 0dh, 0ah, '$'
	ras_klaida_eil db 'Bylos rasymo klaida!', 0dh, 0ah, '$'
	ne_skaicius_eil db 'Parametras turi buti skaicius!', 0dh, 0ah, '$'
	nera_duom_rez_eil db 'Reikia nurodyti duomenu ir rezultatu failus$', 0dh, 0ah, '$'

;******************************************************************************
.CODE
	assume cs:_TEXT, ss:STACK, ds:_DATA
	
	;**************************************************************************
	; pagrindinė programos procedūra MAIN
	;**************************************************************************
	MAIN proc far
		; Inicializuojam programos įėjimo adresą
		push ds
		sub	ax, ax
		push ax
		mov	ax, _DATA
		mov	ds, ax
		
		; nagrinėjam komandinę eilutę
		
		; gauname programos parametrus
		call GET_ARGS
		
		; jei parametrų nėra - spausdiname info
		cmp argn, 0
		je USAGE
		
		
		mov cx, [argn]
		mov si, offset args
	NAGR_PARAM:
		mov bp, [si]
		cmp byte ptr ds:[bp], '/'		; parametras?
		je NUSTAT_PARAM
		
		; nustatom failą:
		; duom, jei dar nenustatytas; rez, jei duom jau nustatytas
		cmp [duom], 0
		jne NUSTAT_REZ_BYLA
		mov [duom], bp
		jmp NUSTAT_BYLA_TOLIAU
	NUSTAT_REZ_BYLA:
		cmp [rez], 0
		jne USAGE
		mov [rez], bp
	NUSTAT_BYLA_TOLIAU:
		jmp NAGR_PARAM_TOLIAU
		
		; nustatom parametrą
	NUSTAT_PARAM:
		cmp byte ptr ds:[bp+1], 'c'
		je PARAM_READC
		; neatpažintas parametras - spausdiname info ir išeinam
		jmp USAGE
	
	NAGR_PARAM_TOLIAU:
		add si, 2
		loop NAGR_PARAM
	
		cmp duom, 0
		je NERA_BYLU
		cmp rez, 0
		je NERA_BYLU
		
		;**********************************************************************
		call SKAITYTI_DUOM
		cmp ax, 0
		jne BAIGTI
		call RASYTI_REZ
		cmp ax, 0
		jne BAIGTI
		ret
		;**********************************************************************
	
	NERA_BYLU:
		mov ah, PRINT
		mov dx, offset nera_duom_rez_eil
		int 21h
		ret
		
	USAGE:
		mov ah, PRINT
		mov dx, offset usage_eil
		int 21h
	BAIGTI:
		ret
	
	; žiūrim po kiek baitų reikės nuskaityti
	PARAM_READC:
		dec cx
		jz USAGE
		add si, 2
		mov bp, [si]
		xor ax, ax
	PARAM_READC_CIKLAS:
		mov bl, byte ptr ds:[bp]
		cmp bl, 0
		je PARAM_READC_TOLIAU
		sub bl, '0'
		jc SKAICIAUS_KLAIDA
		cmp bl, 9
		jnc SKAICIAUS_KLAIDA
		mul desimt
		add al, bl
		inc bp
		jmp PARAM_READC_CIKLAS
	PARAM_READC_TOLIAU:
		mov [readc], al
		jmp NAGR_PARAM_TOLIAU
	
	SKAICIAUS_KLAIDA:
		mov ah, PRINT
		mov dx, offset ne_skaicius_eil
		int 21h
		ret
	MAIN endp
	
	;**************************************************************************
	; GET_ARGS - gauna koamndinės eilutės parametrus ir įrašo į argn, args,
	;	cline
	;**************************************************************************
	GET_ARGS proc near
		push es
		push ds
		push ax
		push bx
		
		; gauname PSP
		mov ah, GETPSP
		int 21h
	
		; Nukopijuojam eilutę į _DATA:cline
		
		; DS = PSP, ES = Data
		mov	ds, bx
		mov	ax, _DATA
		mov	es, ax
		; DI = cline, SI = eilutės pradžia, CX = eilutės ilgis
		mov	di, offset cline
		mov	si, 81h
		mov	cl, [ds:80h]
		xor	ch, ch
		; while (cx--) (*es:di)++ = (*ds:si)++;	
		cld			; clear direction - adresai cikle didės
		rep	movsb
		
		; CX = eilutės ilgis, DS = _DATA, SI = 0, BP = 0, al = ' ', di = cline
		mov	cl, [ds:80h]
		mov	ax, _DATA
		mov	ds, ax
		xor	si, si		; čia bus offsetas nuo args pradžios
		xor	bp, bp		; čia bus si/2, suskaičiuotų argumentų skaičius
		mov	al, ' '
		mov	di, offset cline
	
	ARGS_CIKLAS:
		; šita instrukcija iššoka iš ciklo jei CX=0 arba [es:di]=al
		repne scasb			; ieškom tarpo
		jcxz ARGS_BAIGTI	; jei pasiekėm galą (CX=0)
		; įdedam nuorodą į args
		mov	[args + si], di
		mov	byte ptr [di-1], 0; vietoj 20h įstatom 00h
		add	si, 2
		inc	bp
		jmp	ARGS_CIKLAS
		
	ARGS_BAIGTI:	
		mov	[argn], bp
				
		pop	bx
		pop	ax
		pop	ds
		pop	es
		ret
	GET_ARGS endp
	
	
	;**************************************************************************
	; SKAITYTI_DUOM - skaito duomenis iš failo
	;**************************************************************************
	SKAITYTI_DUOM proc near
		push dx
		
		; atidarome failą
		mov ah, OPEN
		mov al, 0				; read only
		mov dx, [duom]
		int 21h
		jnc SKAITYTI_DUOM_TESTI
		; jei klaida - išeiti
		mov	ah, PRINT
		mov dx, offset skait_klaida_eil
		int 21h
		pop dx
		ret
		
	SKAITYTI_DUOM_TESTI:
		; failo handle patalpinama į duomh
		mov duomh, ax
		
		push bx
		push cx
		push si
		push di
		
	SKAITYTI_DUOM_CIKLAS:
		; skaitome i buferį
		mov ah, READ
		mov bx, duomh
		xor cx, cx
		mov cl, [readc]			; bandom skaityti readc baitų
		mov dx, offset buf
		int 21h
		jc SKAITYTI_DUOM_KLAIDA
		
		mov cx, ax				; ax - nuskaitytų baitų skaičius
		mov si, offset buf
		mov di, offset rez_lent
	SKAITYTI_DUOM_CIKLAS2:
		xor bx, bx
		mov bl, byte ptr [si]
		add bx, bx
		inc byte ptr ds:[di+bx]
		inc si
		loop SKAITYTI_DUOM_CIKLAS2
		
		cmp al, [readc]
		je SKAITYTI_DUOM_CIKLAS
		
		
		jmp SKAITYTI_DUOM_BAIGTI
	
	SKAITYTI_DUOM_KLAIDA:
		mov	ah, PRINT
		mov dx, offset skait_klaida_eil
		int 21h
		
	SKAITYTI_DUOM_BAIGTI:
		; uždaromas duomenų failas
		mov ah, CLOSE
		mov bx, duomh
		int 21h
		mov ax, 0
		
		pop di
		pop si
		pop cx
		pop bx
		pop dx
		ret
	SKAITYTI_DUOM endp
	
	;**************************************************************************
	; RASYTI_REZ - skaito duomenis iš failo
	;**************************************************************************
	RASYTI_REZ proc near
		push cx
		push dx
		
		; sukuriame rezultatų failą
		mov ah, CREATE
		mov cx, 20h
		mov dx, [rez]
		int 21h
		jnc RASYTI_REZ_TOLIAU
		; jei handle nenustatyta - išeiti
		mov ah, PRINT
		mov dx, offset ras_klaida_eil
		int 21h
		pop dx
		pop cx
		ret
		
	RASYTI_REZ_TOLIAU:
		mov rezh, ax			; failo handle patalpinama į rezh
		
		push bx
		push si
		push di
		
		xor cx, cx
		mov si, offset rez_lent
	RASYTI_REZ_CIKLAS:
		mov di, offset rez_buf
		
		xor ax, ax
		mov al, cl
		call RASYTI_SK
		
		mov byte ptr [di], 09h
		mov byte ptr [di+1], 27h
		cmp cx, 20h
		ja RASYTI_REZ_VIZ
		mov byte ptr [di+2], ' '
		jmp RASYTI_REZ_TOLIAU2
	RASYTI_REZ_VIZ:
		mov byte ptr [di+2], cl
	RASYTI_REZ_TOLIAU2:
		mov byte ptr [di+3], 27h
		mov byte ptr [di+4], 09h
		add di, 5
		
		mov ax, [si]
		call RASYTI_SK
		
		mov byte ptr [di], 0ah
		mov byte ptr [di+1], 0dh
		inc di
		
		; rašome rezultatų buferio turinį
		mov ah, WRITE
		mov bx, rezh
		push cx
		mov cx, di
		sub cx, offset rez_buf
		mov dx, offset rez_buf
		int 21h
		pop cx
		jc RASYTI_REZ_KLAIDA
		
		add si, 2
		cmp cl, 0ffh
		jz RASYTI_REZ_BAIGTI
		inc cl
		jmp RASYTI_REZ_CIKLAS
	
	
	RASYTI_REZ_KLAIDA:
		mov ah, PRINT
		mov dx, offset ras_klaida_eil
		int 21h
	
	RASYTI_REZ_BAIGTI:
		; uždaromas rezultatų failas
		mov ah, CLOSE
		mov bx, rezh
		int 21h
		mov ax, 0
		
		pop di
		pop si
		pop bx
		pop dx
		pop cx
		ret
	RASYTI_REZ endp
	
	;**************************************************************************
	; procedūra RASYTI_SK - į buferį rašo skaičių be ženklo
	;	ax - skaičius, di - buferio adresas
	;**************************************************************************
	RASYTI_SK proc near
		push	cx
		push	dx
		
		; jei iš pradžių nulis - rašom '0' ir išeinam
		cmp		ax, 0
		jne		RASYTI_SK_TESTI
		mov		byte ptr [di], "0"
		inc		di
		jmp		BAIGTI_RASYTI_SK
		
	RASYTI_SK_TESTI:
		; skaičiaus skaitmenys sukeliami į steką
		xor		cx, cx
	RASYTI_SK_CIKLAS1:
		cmp		ax, 0
		je		RASYTI_SK_CIKLAS2
		xor		dx, dx
		div		desimt		; ax - dalmuo, dx - liekana, daliklis=10
		push	dx
		inc		cx
		jmp		RASYTI_SK_CIKLAS1
	
		; skaitmenys nuskaitomi iš steko ir įrašomi į buferį
	RASYTI_SK_CIKLAS2:
		cmp		cx, 0
		je		BAIGTI_RASYTI_SK
		pop		dx
		add		dl, '0'
		mov		byte ptr [di], dl
		inc		di
		dec		cx
		jmp		RASYTI_SK_CIKLAS2
		
	BAIGTI_RASYTI_SK:
		pop		dx
		pop		cx
		ret
	RASYTI_SK endp

end MAIN

