; Ši programa ekrane piešia paveiksliuką ir keičia jo spalvas
; BŪTINAI reikalingas failiukas asm1_2.pav, saugantis paveiksliuką

.MODEL SMALL
.386

; konstantos
AUKSTIS equ 200			; mūsų naudojamas ekrano aukštis..
PLOTIS equ 320			; ..ir plotis
KRASTINE equ 20			; kvadrato kraštinė
SPALVA equ 200			; kvadrato spalva

SET_320x200 equ 13h		; set video mode pertraukimo parametras
SET_80x25 equ 03h		; set video mode pertraukimo parametras
EXIT equ 4c00h			; išėjimo iš programos pertraukimo parametras
INPUT equ 07h			; įvedimo pertraukimo parametras
OPEN equ 3dh			; failo atidarymas
READ equ 3fh			; failo skaitymas
CLOSE equ 3eh			; failo uzdarymas

.STACK
.DATA
	video_seg dw 0a000h
	failas db "asm1_2.pav"
	handle dw 0
	palete db 768 dup (?)
.CODE

; pagrindinė funkcija
MAIN proc far
	mov ax, _DATA
	mov ds, ax			; nustatomas duomenų segmento registras
	mov ax, video_seg
	mov es, ax			; nustatomas video segmentas
	
	mov ax, SET_320x200
	int 10h				; persijungiama į grafikos režimą 320x200x256
	
	mov di, offset palete
	call GENER_PALETE	; generuojama palete
	mov si, offset palete
	call NUSTAT_PALETE	; suaktyvinama palete
	call SKAIT_FAIL		; ikeliamas pradinis paveiksliukas
	
	; vykdomi perejimai
	mov cx, 128
MAIN_LOOP1:
	call PEREJIMAS
	dec cx
	jnz MAIN_LOOP1
	
	mov ah, INPUT
	int 21h				; laukiama klavišo paspaudimo
	
	mov ax, SET_80x25
	int 10h				; grįžtama į textinį režimą
	
	mov ax, EXIT
	int 21h				; išeinama iš programos
MAIN endp

; ekrane piešia kvadratą: x=bx, y=dx
;PIESTI_KV proc near
;	mov ax, PLOTIS
;	mul dx
;	add ax, bx
;	mov di, ax
;
;	mov ax, KRASTINE
;CIKLAS0:
;	mov cx, KRASTINE
;	add di, PLOTIS-KRASTINE
;	
;CIKLAS1:
;	mov byte ptr es:[di], SPALVA
;	inc di
;	loop CIKLAS1			; grįžtama į CIKLAS1 pradžią
;	
;	dec ax
;	jnz CIKLAS0				; grįžtama į CIKLAS0 pradžią
;	
;	ret
;PIESTI_KV endp

; nuskaito paveikslo faila ir patalpina i video segmenta
SKAIT_FAIL proc near
	; atidaromas failas
	mov ah, OPEN
	mov al, 0				; read only
	mov dx, offset failas
	int 21h
	
	cmp ax, 0
	je BAIGTI_SKAIT_FAIL	; jei handle nenustatyta, iseiti
	
	mov handle, ax			; failo handle patalpinama i kintamaji
	
	; skaitoma i video atminti
	push ds
	mov ah, READ
	mov bx, handle
	mov cx, 64000
	mov ds, video_seg
	xor dx, dx
	int 21h
	pop ds
	
	; uzdaromas failas
	mov ah, CLOSE
	mov bx, handle
	int 21h
BAIGTI_SKAIT_FAIL:
	ret
SKAIT_FAIL endp

; generuojama palete
GENER_PALETE proc near
	; pirmos 128 spalvos - juoda
	mov cx, 384					; 384 = 128*3
GP_CIKLAS1:
	mov byte ptr [di], 0
	inc di
	dec cx
	jnz GP_CIKLAS1
	
	mov cx, 128					; ciklas 128 kartus
GP_CIKLAS:
	; nustatoma spalva
	mov bl, 128
	sub bl, cl
	shl bl, 1
	mov [di], bl
	inc di
	mov [di], bl
	inc di
	mov [di], bl
	inc di
	
	dec cx
	jnz GP_CIKLAS
	
	ret
GENER_PALETE endp

; aktyvuojama palete
NUSTAT_PALETE proc near
	mov cx, 768
	mov dx, 3c8h
	xor al, al
	out dx, al
	inc dx
	rep outsb
	ret
NUSTAT_PALETE endp

; daromas spalvu perejimas per 1 reiksme
PEREJIMAS proc near
	xor di, di
PER_CIKLAS:
	cmp byte ptr es:[di], 255
	je PER_TESTI
	inc byte ptr es:[di]
	
PER_TESTI:
	inc di
	cmp di, 64000
	jne PER_CIKLAS
	
	ret
PEREJIMAS endp

END MAIN
