// Ši programa skirta *.bmp faila paversti į asm1_2 programai tinkamą formatą.
// Ji iš paveiksliuko išskiria paskutinius 64000 (=320x200) baitus ir įrašo į
// naują failą

#include <fstream>
#include <iostream>

using namespace std;

const char NAUDOJIMAS[] = "Naudojimas: bmp2pav <bmp_failas> [<pav_failas>]\n";
const char BLOG_IN_FAILAS[] = "Nepavyko atidaryti failo: ";
const char BLOG_OUT_FAILAS[] = "Nepavyko sukurti failo: ";
const char BLOG_IN_DYDIS[] = "Per mazas failas ";
char PAV_VARDAS[] = "asm1_2.pav";

int main(int argn, char** args)
{
	if (argn == 1)
	{
		cout << NAUDOJIMAS;
		return 0;
	}
	
	ifstream inf(args[1]);
	if (!inf.is_open())
	{
		cout << BLOG_IN_FAILAS << args[1] << endl;
		return 0;
	}
	
	char* out_vardas;
	if (argn >= 3) out_vardas = args[2];
	else out_vardas = PAV_VARDAS;
	
	ofstream outf(out_vardas);
	if (!outf.is_open())
	{
		cout << BLOG_OUT_FAILAS << out_vardas << endl;
		return 0;
	}
	
	// gauti in bylos dydį
	inf.seekg (0, ios::end);
	int dyd = inf.tellg();
	if (dyd < 64000)
	{
	    cout << BLOG_IN_DYDIS << args[1] << endl;
	    return 0;
	}    
	
	// nustatoma failo rodykle i atitinkama pozicija
	inf.seekg(-64000, ios::end);
	
	char *buf = new char[3200];
	for (int i=0; i<20; i++)
	{
		inf.read(buf, 3200);
		outf.write(buf, 3200);
	};	
	inf.close();
	outf.close();
	delete[] buf;
}
